#include <err.h>
#include <stdio.h>
#include <vector>

#include "abac.hh"
#include "abac_util.h"

using namespace ABAC;
using std::vector;

int main(int argc, char **argv) {
    int i;
    abac_credential_t *cred;

    if (argc < 2)
        errx(1, "Usage: %s <keystore>", argv[0]);

    libabac_init();

    Context ctx;
    ctx.load_directory(argv[1]);

    debug_printf("querying\n");

    bool success;
    vector<Credential> credentials = ctx.query(
        "3f1aca4c5911b345d81c5f1a77675dce13249d0c.fed_create",
        "5839d714b16bbe108642c5eb586c2173420bed19",
        success
    );

    if (success)
        puts("success");
    for (vector<Credential>::iterator i = credentials.begin(); i != credentials.end(); ++i) {
        printf("credential %s <- %s\n",
            i->head().string(),
            i->tail().string()
        );
    }

    libabac_deinit();

    return 0;
}
